
declare table_thick = 2
declare table_height = 40

declare table_width = 40
declare table_length = 96

declare table_leg_inset = 3

declare table_gap = .5
declare table_leg_thick = 1



declare table_wood = texture
    {
    pigment { DMFDarkOak turbulence .1 scale 3 rotate <0, 90, 5> translate <5, 20, 0>}
    finish { ambient 0.1 reflection 0.03 diffuse 0.5 }
    }

declare table_leg = cylinder
	{
	<-table_thick, 0, 0>, <-table_height, 0, 0>, table_leg_thick
	}
declare tl = table_length
declare tw = table_width
declare sw = table_length/20
declare th = table_thick
declare tg = table_gap

declare table = union
    {
    box {<-tl/2+0*sw, 0, -tw/2>, <-tl/2+1*sw-tg, -th, tw/2>
	     texture { table_wood translate 10*sw*x/2 rotate 90*y rotate 90*z}}
    box {<-tl/2+1*sw, 0, -tw/2>, <-tl/2+2*sw-tg, -th, tw/2>
	     texture { table_wood translate 9*sw*x/2 rotate 90*y rotate 180*z}}
    box {<-tl/2+2*sw, 0, -tw/2>, <-tl/2+3*sw-tg, -th, tw/2>
	     texture { table_wood translate 8*sw*x/2 rotate 90*y}}
    box {<-tl/2+3*sw, 0, -tw/2>, <-tl/2+4*sw-tg, -th, tw/2>
	     texture { table_wood translate 7*sw*x/2 rotate 90*y rotate -90*z}}
    box {<-tl/2+4*sw, 0, -tw/2>, <-tl/2+5*sw-tg, -th, tw/2>
	     texture { table_wood translate 6*sw*x/2 rotate 90*y rotate 90*z}}
    box {<-tl/2+5*sw, 0, -tw/2>, <-tl/2+6*sw-tg, -th, tw/2>
	     texture { table_wood translate 5*sw*x/2 rotate 90*y rotate 180*z}}
    box {<-tl/2+6*sw, 0, -tw/2>, <-tl/2+7*sw-tg, -th, tw/2>
	     texture { table_wood translate 4*sw*x/2 rotate 90*y rotate -90*z}}
    box {<-tl/2+7*sw, 0, -tw/2>, <-tl/2+8*sw-tg, -th, tw/2>
	     texture { table_wood translate 3*sw*x/2 rotate 90*y}}
    box {<-tl/2+8*sw, 0, -tw/2>, <-tl/2+9*sw-tg, -th, tw/2>
	     texture { table_wood translate 2*sw*x/2 rotate 90*y rotate 90*z}}
    box {<-tl/2+9*sw, 0, -tw/2>, <-tl/2+10*sw-tg,-th, tw/2>
	     texture { table_wood translate 1*sw*x/2 rotate 90*y rotate 180*z}}
    box {<-tl/2+10*sw, 0, -tw/2>, <-tl/2+11*sw-tg,-th, tw/2>
	     texture { table_wood translate 1*sw*x/2 rotate 90*y rotate 180*z}}
    box {<-tl/2+11*sw, 0, -tw/2>, <-tl/2+12*sw-tg,-th, tw/2>
	     texture { table_wood translate 1*sw*x/2 rotate 90*y rotate 180*z}}
    box {<-tl/2+12*sw, 0, -tw/2>, <-tl/2+13*sw-tg,-th, tw/2>
	     texture { table_wood translate 1*sw*x/2 rotate 90*y rotate 180*z}}
    box {<-tl/2+13*sw, 0, -tw/2>, <-tl/2+14*sw-tg,-th, tw/2>
	     texture { table_wood translate 1*sw*x/2 rotate 90*y rotate 180*z}}
    box {<-tl/2+14*sw, 0, -tw/2>, <-tl/2+15*sw-tg,-th, tw/2>
	     texture { table_wood translate 1*sw*x/2 rotate 90*y rotate 180*z}}
    box {<-tl/2+15*sw, 0, -tw/2>, <-tl/2+16*sw-tg,-th, tw/2>
	     texture { table_wood translate 1*sw*x/2 rotate 90*y rotate 180*z}}
    box {<-tl/2+16*sw, 0, -tw/2>, <-tl/2+17*sw-tg,-th, tw/2>
	     texture { table_wood translate 1*sw*x/2 rotate 90*y rotate 180*z}}
    box {<-tl/2+17*sw, 0, -tw/2>, <-tl/2+18*sw-tg,-th, tw/2>
	     texture { table_wood translate 1*sw*x/2 rotate 90*y rotate 180*z}}
    box {<-tl/2+18*sw, 0, -tw/2>, <-tl/2+19*sw-tg,-th, tw/2>
	     texture { table_wood translate 1*sw*x/2 rotate 90*y rotate 180*z}}
    box {<-tl/2+19*sw, 0, -tw/2>, <-tl/2+20*sw-tg,-th, tw/2>
	     texture { table_wood translate 1*sw*x/2 rotate 90*y rotate 180*z}}

    object { table_leg texture { table_wood } rotate 90*z
       translate <-(table_length/2 - table_leg_inset), 0, -(table_width/2 - table_leg_inset)> }
    object { table_leg texture { table_wood } rotate 90*z
       translate < (table_length/2 - table_leg_inset), 0, -(table_width/2 - table_leg_inset)> }
    object { table_leg texture { table_wood } rotate 90*z
       translate <-(table_length/2 - table_leg_inset), 0,  (table_width/2 - table_leg_inset)> }
    object { table_leg texture { table_wood } rotate 90*z
       translate < (table_length/2 - table_leg_inset), 0,  (table_width/2 - table_leg_inset)> }

    box { <-(tl/2 - table_leg_inset), -th,    -(tw/2 - table_leg_inset)>,
	  <  tl/2 - table_leg_inset,  -th-sw, -(tw/2 - table_leg_inset-th)>
	  texture { table_wood }
	  }
    box { <-(tl/2 - table_leg_inset), -th,     (tw/2 - table_leg_inset)>,
	  <  tl/2 - table_leg_inset,  -th-sw,  (tw/2 - table_leg_inset-th)>
	  texture { table_wood }
	  }

    box { <-(tl/2 - table_leg_inset),    -th,   -(tw/2 - table_leg_inset)>
	  <-(tl/2 - table_leg_inset-th), -th-sw, (tw/2 - table_leg_inset)>
	  texture { table_wood rotate 90*y}
	  }
    box { <(tl/2 - table_leg_inset),    -th,   -(tw/2 - table_leg_inset)>
	  <(tl/2 - table_leg_inset-th), -th-sw, (tw/2 - table_leg_inset)>
	  texture { table_wood rotate 90*y}
	  }
    }
